# vorbisenc

This element encodes raw float audio into a Vorbis stream. Vorbis is a royalty-free audio codec maintained by the Xiph.org Foundation.

## Example pipelines

     gst-launch-1.0 -v audiotestsrc wave=sine num-buffers=100 ! audioconvert ! vorbisenc ! oggmux ! filesink location=sine.ogg

Encode a test sine signal to Ogg/Vorbis. Note that the resulting file will be really small because a sine signal compresses very well.

     gst-launch-1.0 -v autoaudiosrc ! audioconvert ! vorbisenc ! oggmux ! filesink location=alsasrc.ogg

Record from a sound card and encode to Ogg/Vorbis.

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstAudioEncoder
                        ╰──vorbisenc

## Implemented interfaces

    GstPreset
    GstTagSetter

## Factory details

Authors: – Monty <monty>, Wim Taymans <wim></wim></monty>

Classification: – `Codec/Encoder/Audio`

Rank – primary

Plugin – vorbis

Package – GStreamer Base Plug-ins

## Pad Templates

### `sink`

    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 1
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 2
       channel-mask: 0x0000000000000003
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 3
       channel-mask: 0x0000000000000007
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 4
       channel-mask: 0x0000000000000033
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 5
       channel-mask: 0x0000000000000037
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 6
       channel-mask: 0x000000000000003f
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 7
       channel-mask: 0x0000000000000d0f
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: 8
       channel-mask: 0x0000000000000c3f
    audio/x-raw:
             format: F32LE
             layout: interleaved
               rate: [ 1, 200000 ]
           channels: [ 9, 255 ]
       channel-mask: 0x0000000000000000

Presence – always

Direction – sink

Object type – GstPad

### `src`

    audio/x-vorbis:
               rate: [ 1, 200000 ]
           channels: [ 1, 255 ]

Presence – always

Direction – src

Object type – GstPad

## Properties

### bitrate

    “bitrate” gint

Attempt to encode at a bitrate averaging this (in bps). This uses the bitrate management engine, and is not recommended for most users. Quality is a better alternative. (-1 == disabled)

Flags : Read / Write

Default value : -1

### last-message

    “last-message” gchararray

The last status message

Flags : Read

Default value : NULL

### managed

    “managed” gboolean

Enable bitrate management engine

Flags : Read / Write

Default value : false

### max-bitrate

    “max-bitrate” gint

Specify a maximum bitrate (in bps). Useful for streaming applications. (-1 == disabled)

Flags : Read / Write

Default value : -1

### min-bitrate

    “min-bitrate” gint

Specify a minimum bitrate (in bps). Useful for encoding for a fixed-size channel. (-1 == disabled)

Flags : Read / Write

Default value : -1

### quality

    “quality” gfloat

Specify quality instead of specifying a particular bitrate.

Flags : Read / Write

Default value : 0.3

The results of the search are